#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct JournalTimestampMetadata {
    #[builder(into)]
    #[serde(rename = "fieldName")]
    field_name: String,
    #[builder(custom(type = super::EpochTimestamp, convert = Box::new))]
    #[serde(rename = "epochOfTimeUnit")]
    epoch_of_time_unit: Box<super::EpochTimestamp>,
}
impl JournalTimestampMetadata {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        field_name: impl Into<String>,
        epoch_of_time_unit: super::EpochTimestamp,
    ) -> Self {
        Self::builder()
            .field_name(field_name)
            .epoch_of_time_unit(epoch_of_time_unit)
            .build()
    }
    #[inline]
    pub fn field_name(&self) -> &str {
        &*self.field_name
    }
    #[inline]
    pub fn epoch_of_time_unit(&self) -> &super::EpochTimestamp {
        &*self.epoch_of_time_unit
    }
}
